VERSION 2.00
Begin Form SortForm 
   Caption         =   "Sorting"
   ClientHeight    =   3135
   ClientLeft      =   2160
   ClientTop       =   1515
   ClientWidth     =   4695
   Height          =   3825
   Left            =   2100
   LinkTopic       =   "Form1"
   ScaleHeight     =   3135
   ScaleWidth      =   4695
   Top             =   885
   Width           =   4815
   Begin TextBox NumRepsText 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1200
      TabIndex        =   15
      Text            =   "1"
      Top             =   840
      Width           =   1095
   End
   Begin TextBox NumUnsortedText 
      Alignment       =   1  'Right Justify
      Enabled         =   0   'False
      Height          =   285
      Left            =   1200
      TabIndex        =   13
      Text            =   "0"
      Top             =   1680
      Width           =   1095
   End
   Begin CheckBox SortedCheck 
      Caption         =   "Start Sorted"
      Height          =   255
      Left            =   600
      TabIndex        =   12
      Top             =   1320
      Width           =   1335
   End
   Begin Frame Frame1 
      Caption         =   "Algorithm"
      Height          =   1935
      Left            =   2640
      TabIndex        =   9
      Top             =   120
      Width           =   1935
      Begin OptionButton SortOption 
         Caption         =   "Bubblesort"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   11
         Top             =   360
         Value           =   -1  'True
         Width           =   1455
      End
      Begin OptionButton SortOption 
         Caption         =   "Selectionsort"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   2
         Top             =   720
         Width           =   1455
      End
      Begin OptionButton SortOption 
         Caption         =   "Quicksort"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   3
         Top             =   1080
         Width           =   1455
      End
      Begin OptionButton SortOption 
         Caption         =   "Countingsort"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   4
         Top             =   1440
         Width           =   1455
      End
   End
   Begin CommandButton CmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   495
      Left            =   3240
      TabIndex        =   5
      Top             =   2160
      Width           =   735
   End
   Begin TextBox NumItemsText 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1200
      TabIndex        =   0
      Text            =   "1000"
      Top             =   120
      Width           =   1095
   End
   Begin TextBox MaxValueText 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   1200
      TabIndex        =   1
      Text            =   "10000"
      Top             =   480
      Width           =   1095
   End
   Begin Label Label1 
      Caption         =   "Repetitions"
      Height          =   255
      Index           =   4
      Left            =   120
      TabIndex        =   16
      Top             =   840
      Width           =   975
   End
   Begin Label NumUnsortedLabel 
      Caption         =   "# Unsorted"
      Enabled         =   0   'False
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   1680
      Width           =   975
   End
   Begin Label TimeLabel 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   3360
      TabIndex        =   10
      Top             =   2760
      Width           =   1095
   End
   Begin Label Label1 
      Caption         =   "Time"
      Height          =   255
      Index           =   2
      Left            =   2760
      TabIndex        =   8
      Top             =   2760
      Width           =   495
   End
   Begin Label Label1 
      Caption         =   "# Items"
      Height          =   255
      Index           =   0
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   855
   End
   Begin Label Label1 
      Caption         =   "Max Value"
      Height          =   255
      Index           =   1
      Left            =   120
      TabIndex        =   6
      Top             =   480
      Width           =   975
   End
   Begin Menu mnuFile 
      Caption         =   "&File"
      Begin Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Option Explicit

Dim Algorithm As Integer
Dim NumItems As Integer
Dim MaxValue As Long
Dim NumUnsorted As Integer
Dim NumReps As Integer
Dim List() As Long
Dim SortedList() As Long

Dim ellapsed_time As Double

' *******************************************************
' Bubblesort with:
'   - Alternating upward and downward passes
'   - Holding bubbled item in a temporary variable
'   - Updating min and max to narrow the search range
' *******************************************************
Sub BubbleSort (List() As Long, ByVal min As Integer, ByVal max As Integer)
Dim last_swap As Integer
Dim i As Integer
Dim j As Integer
Dim tmp As Long
    
    ' Repeat until we are done.
    Do While min < max
        ' Bubble up.
        last_swap = min - 1
        ' For i = min + 1 To max
        i = min + 1
        Do While i <= max
            ' Find a bubble.
            If List(i - 1) > List(i) Then
                ' See where to drop the bubble.
                tmp = List(i - 1)
                j = i
                Do
                    List(j - 1) = List(j)
                    j = j + 1
                    If j > max Then Exit Do
                Loop While List(j) < tmp
                List(j - 1) = tmp
                last_swap = j - 1
                i = j + 1
            Else
                i = i + 1
            End If
        Loop
        ' Update max.
        max = last_swap - 1
        
        ' Bubble down.
        last_swap = max + 1
        ' For i = max - 1 To min Step -1
        i = max - 1
        Do While i >= min
            ' Find a bubble.
            If List(i + 1) < List(i) Then
                ' See where to drop the bubble.
                tmp = List(i + 1)
                j = i
                Do
                    List(j + 1) = List(j)
                    j = j - 1
                    If j < min Then Exit Do
                Loop While List(j) > tmp
                List(j + 1) = tmp
                last_swap = j + 1
                i = j - 1
            Else
                i = i - 1
            End If
        Loop
        ' Update min.
        min = last_swap + 1
    Loop
End Sub

' *******************************************************
' If NumItems, MaxValue, and NumUnsorted have not changed
' since the last time, do nothing. This allows the user
' to try the same list for each algorithm.
'
' Otherwise make the random list.
' *******************************************************
Sub BuildList ()
Static last_num As Integer
Static last_max As Long
Static last_unsorted As Long

Dim i As Integer
Dim j As Integer
Dim k As Integer
Dim temp As Long

    If last_num = NumItems And last_max = MaxValue And last_unsorted = NumUnsorted Then Exit Sub
    last_num = NumItems
    last_max = MaxValue
    last_unsorted = NumUnsorted

    ' Make the random items.
    ReDim List(1 To NumItems)
    ReDim SortedList(1 To NumItems)
    For i = 1 To NumItems
        List(i) = Int(MaxValue * Rnd + 1)
    Next i

    ' Sort the list if necessary.
    If SortedCheck.Value <> 1 Then Exit Sub
    Quicksort List(), 1, NumItems

    ' Swap items to make NumUnsorted items out of order.
    For i = 1 To NumUnsorted / 2
        j = Int(NumItems * Rnd + 1)
        k = Int(NumItems * Rnd + 1)
        temp = List(j)
        List(j) = List(k)
        List(k) = temp
    Next i
End Sub

' *******************************************************
' Make sure the sort worked.
' *******************************************************
Sub CheckSort ()
Dim i As Integer

    For i = 2 To NumItems
        If SortedList(i - 1) > SortedList(i) Then
            Beep
            MsgBox "SortedList(" & Format$(i - 1) & ") =" & Str$(SortedList(i - 1)) & ", SortedList(" & Format$(i) & ") =" & Str$(SortedList(i)) & "."
            Exit Sub
        End If
    Next i
End Sub

Sub CmdGo_Click ()
    MousePointer = 11   ' Hourglass pointer.
    
    If Not IsNumeric(NumItemsText.Text) Then NumItemsText.Text = "1000"
    If Not IsNumeric(MaxValueText.Text) Then MaxValueText.Text = "1000"
    If Not IsNumeric(NumRepsText.Text) Then NumRepsText.Text = "1"
    If Not IsNumeric(NumUnsortedText.Text) Then NumUnsortedText.Text = "0"

    NumItems = CInt(NumItemsText.Text)
    MaxValue = CLng(MaxValueText.Text)
    NumReps = CInt(NumRepsText.Text)
    If SortedCheck.Value = 1 Then
        NumUnsorted = CInt(NumUnsortedText.Text)
    Else
        NumUnsorted = NumUnsorted + 1
    End If

    BuildList
    SortItems
    CheckSort
    MousePointer = 0    ' Normal pointer.
End Sub

' *******************************************************
' Countingsort.
' *******************************************************
Sub Countingsort (List() As Long, sorted_list() As Long, min As Integer, max As Integer, min_value As Long, max_value As Long)
Dim counts() As Integer
Dim i As Integer
Dim this_count As Integer
Dim next_offset As Integer

    ' Create the Counts array.
    ReDim counts(min_value To max_value)

    ' Count the items.
    For i = min To max
        counts(List(i)) = counts(List(i)) + 1
    Next i

    ' Convert the counts into offsets.
    next_offset = min
    For i = min_value To max_value
        this_count = counts(i)
        counts(i) = next_offset
        next_offset = next_offset + this_count
    Next i

    ' Place the items in the sorted array.
    For i = min To max
        sorted_list(counts(List(i))) = List(i)
        counts(List(i)) = counts(List(i)) + 1
    Next i
End Sub

Sub mnuFileExit_Click ()
    End
End Sub

' *******************************************************
' Recursively perform the actual quicksort algorithm.
' *******************************************************
Sub Quicksort (List() As Long, min As Integer, max As Integer)
Dim med_value As Long
Dim hi As Integer
Dim lo As Integer
Dim i As Integer

    ' If the list has no more than 1 element, it's sorted.
    If min >= max Then Exit Sub

    ' Pick a dividing item.
    i = Int((max - min + 1) * Rnd + min)
    med_value = List(i)

    ' Swap it to the front so we can find it easily.
    List(i) = List(min)

    ' Move the items smaller than this into the left
    ' half of the list. Move the others into the right.
    lo = min
    hi = max
    Do
        ' Look down from hi for a value < med_value.
        Do While List(hi) >= med_value
            hi = hi - 1
            If hi <= lo Then Exit Do
        Loop
        If hi <= lo Then
            List(lo) = med_value
            Exit Do
        End If

        ' Swap the lo and hi values.
        List(lo) = List(hi)
        
        ' Look up from lo for a value >= med_value.
        lo = lo + 1
        Do While List(lo) < med_value
            lo = lo + 1
            If lo >= hi Then Exit Do
        Loop
        If lo >= hi Then
            lo = hi
            List(hi) = med_value
            Exit Do
        End If
        
        ' Swap the lo and hi values.
        List(hi) = List(lo)
    Loop
    
    ' Sort the two sublists
    Quicksort List(), min, lo - 1
    Quicksort List(), lo + 1, max
End Sub

' *******************************************************
' Use bubblesort.
' *******************************************************
Sub RunBubblesort ()
Dim start_time As Double
Dim rep As Integer
Dim i As Integer

    ellapsed_time = 0#
    For rep = 1 To NumReps
        ' Copy the list into the SortedList array.
        For i = 1 To NumItems
            SortedList(i) = List(i)
        Next i
    
        start_time = Timer
        BubbleSort SortedList(), 1, NumItems
        ellapsed_time = ellapsed_time + Timer - start_time
    Next rep
End Sub

' *******************************************************
' Use countingsort to sort the items.
' *******************************************************
Sub RunCountingsort ()
Dim start_time As Double
Dim rep As Integer
Dim i As Integer

    ellapsed_time = 0#
    For rep = 1 To NumReps
        start_time = Timer
        Countingsort List(), SortedList(), 1, NumItems, 1, MaxValue
        ellapsed_time = ellapsed_time + Timer - start_time
    Next rep
End Sub

' *******************************************************
' Use quicksort.
' *******************************************************
Sub RunQuicksort ()
Dim start_time As Double
Dim rep As Integer
Dim i As Integer

    ellapsed_time = 0#
    For rep = 1 To NumReps
        ' Copy the list into the SortedList array.
        For i = 1 To NumItems
            SortedList(i) = List(i)
        Next i
    
        start_time = Timer
        Quicksort SortedList(), 1, NumItems
        ellapsed_time = ellapsed_time + Timer - start_time
    Next rep
End Sub

' *******************************************************
' Sort the list using selectionsort.
' *******************************************************
Sub RunSelectionsort ()
Dim start_time As Double
Dim rep As Integer
Dim i As Integer

    ellapsed_time = 0#
    For rep = 1 To NumReps
        ' Copy the list into the SortedList array.
        For i = 1 To NumItems
            SortedList(i) = List(i)
        Next i
    
        start_time = Timer
        Selectionsort SortedList(), 1, NumItems
        ellapsed_time = ellapsed_time + Timer - start_time
    Next rep
End Sub

' *******************************************************
' Selectionsort.
' *******************************************************
Sub Selectionsort (List() As Long, min As Integer, max As Integer)
Dim i As Integer
Dim j As Integer
Dim best_value As Long
Dim best_j As Integer

    For i = min To max - 1
        best_value = List(i)
        best_j = i
        For j = i + 1 To max
            If List(j) < best_value Then
                best_value = List(j)
                best_j = j
            End If
        Next j
        List(best_j) = List(i)
        List(i) = best_value
    Next i
End Sub

Sub SortedCheck_Click ()
    NumUnsortedText.Enabled = (SortedCheck.Value = 1)
    NumUnsortedLabel.Enabled = (SortedCheck.Value = 1)
End Sub

Sub SortItems ()
    TimeLabel.Caption = ""
    Select Case Algorithm
        Case 0
            RunBubblesort
        Case 1
            RunSelectionsort
        Case 2
            RunQuicksort
        Case 3
            RunCountingsort
    End Select
    TimeLabel.Caption = Format$(ellapsed_time, "0.00")
End Sub

Sub SortOption_Click (Index As Integer)
    Algorithm = Index
End Sub

